// Time-stamp: <2013-06-17T07:45:04Z>
//
// Meta Data:
// @encoding	UTF8/Japanese
// @name        Copy_Title_and_URL.js for JSActions
// @namespace   http://jrf.cocolog-nifty.com/
// @version	0.3
// @archive	http://jrf.cocolog-nifty.com/archive/javascript/Copy_Title_and_URL.js
//
// Description (en):
//
// Copy an URL with the title and a selected citation and remove or
// replace "linker" options in the URL for use with the Greasemonkey
// script below.
//
// http://jrf.cocolog-nifty.com/archive/javascript/no_ad_url.user.js
//
//
// Description (ja):
//
// 以下の Greasemonkey スクリプトを利用するときなどのために、linker を
// 書き換えながら URL をコピーする。タイトルや引用も JRF のひとこと風に、
// いっしょにコピーする。書き換え後の linker は jsa_defaultLinker で指
// 定できるが、これが null のときは、linker はすべて取り除く。
//
// http://jrf.cocolog-nifty.com/archive/javascript/no_ad_url.user.js
//

var jsa_defaultLinker = null;
//var jsa_defaultLinker = "Your@Open.ID";
var jsa_defaultLinkee = null;
var jsa_needConfirm = true;

function jsa_replaceLinker(url, newLinker) {
  var args = [];
  var dest = [];
  var linker = [];
  var linkee = [];
  var no_ad = [];

  if (! url.match(/\?/)) {
    return url;
  }
  url = RegExp.leftContext;
  args = RegExp.rightContext.split(/\&/);

  for (var i = 0; i < args.length; i++) {
    if (args[i].match(/^linker=/)) {
      linker.push(decodeURIComponent(RegExp.rightContext));
    } else if (args[i].match(/^linkee=/)) {
      linkee.push(decodeURIComponent(RegExp.rightContext));
    } else if (args[i].match(/^no_ad=/)) {
      no_ad.push(decodeURIComponent(RegExp.rightContext));
    }
  }

  var linkerMode = null;
  var replaceLinkee = false;

  if (newLinker == null) {
    linkerMode = "delete";
  } else { // (newLinker != null)
    if (linkee.length == 0) {
      if (linker.length > 0 || no_ad.length > 0) {
	linkerMode = "add";
	if (jsa_defaultLinkee != null) {
	  replaceLinkee = true;
	}
      } else {
	linkerMode = "delete";
      }
    } else { // (linkee.length > 0)
      replaceLinkee = true;
      linkerMode = "replace";
    }
  }
  if (no_ad.length > 0 || (linker.length > 0 && linkerMode != "delete")) {
    replaceLinkee = true;
  }

  var newLinkee = null;
  if (replaceLinkee) {
    if (jsa_defaultLinkee == null || jsa_needConfirm) {
      newLinkee = window.prompt("Enter the linkee who you tell the link (or empty for public link or SNS link):", (jsa_defaultLinkee || ""));
      if (newLinkee != null) {
	newLinkee.replace(/^\s+/, "");
	newLinkee.replace(/\s+$/, "");
	if (newLinkee == "") {
	  newLinkee = null;
	}
      }
    } else {
      newLinkee = jsa_defaultLinkee;
    }
  }
  if (replaceLinkee && newLinkee == null) {
    replaceLinkee = false;
  }

  for (var i = 0; i < args.length; i++) {
    if (args[i].match(/^linker=/)) {
      if (linkerMode == "replace") {
	dest.push("linker=" + encodeURIComponent(newLinker));
	linkerMode = "delete";
      } else if (linkerMode == "add") {
	dest.push(args[i]);
      } else if (linkerMode == "delete") {
	// delete args[i].
      }
    } else if (args[i].match(/^linkee=/)) {
      if (replaceLinkee) {
	dest.push("linkee=" + encodeURIComponent(newLinkee));
	replaceLinkee = false;
      } else {
	// delete args[i].
      }
    } else {
      dest.push(args[i]);
    }
  }
  if (linkerMode == "add") {
    dest.push("linker=" + encodeURIComponent(newLinker));
  }
  if (replaceLinkee) {
    dest.push("linkee=" + encodeURIComponent(newLinkee));
  }
  if (dest.length > 0) {
    return url + "?" + dest.join("&");
  } else {
    return url;
  }
}

function jsa_copyUrlWithTitle(){
  var url, text;
  var sel;
  if (_jsaCScript.context.isTextSelected) {
    if ("selection" in _jsaCScript.context) {
      sel = _jsaCScript.context.selection;
    } else {
      sel = window.getSelection().toString();
    }
  }
  if(_jsaCScript.context.onLink) {
    url = _jsaCScript.context.link.href;
    text = _jsaCScript.context.link.textContent;
  } else if (document.URL) {
    url = document.URL;
    text = document.title;
  }
  var orig_text = text;
  var orig_url = url;
  text =  _jsaCScript.convertCharCodeFrom(text, "utf8");
  url = jsa_replaceLinker(url, jsa_defaultLinker);
  url =  _jsaCScript.convertCharCodeFrom(url, "utf8");
  if (orig_text != orig_url) {
    text = "《" + text + "》" + "\n" + url
  } else {
    text = url;
  }
  if (sel) {
    sel = _jsaCScript.convertCharCodeFrom(sel, "utf8");
    text =  text + "\n" + "＞" + sel + "＜";
  }
  text = _jsaCScript.convertCharCodeTo(text, "utf8");
  
  _jsaCScript.setClipBoardString(text);
}

jsa_copyUrlWithTitle();
