// Time-stamp: <2014-02-01T17:08:47Z>
// ==UserScript==
// @name        No Ad URL
// @namespace   http://jrf.cocolog-nifty.com/
// @include     *
// @version     0.51
// ==/UserScript==

var no_ad_black_linker = ["anonymous@jrf.cocolog-nifty.com"];
var no_ad_white_linker = ["JRF@jrf.cocolog-nifty.com"];
var no_ad_allow_self_domain_linker = true;

function no_ad_check_linker (url) {
  var s = url;
  var linker = [];
  while (s.match(/[\&\?]linker=([^\&]+)/)) {
    s = RegExp.rightContext;
    var c = decodeURIComponent(RegExp.$1);
    linker.push(c);
  }
  for (var i = 0; i < linker.length; i++) {
    for (var j = 0; j < no_ad_black_linker.length; j++) {
      if (linker[i] == no_ad_black_linker[j]) {
	return false;
      }
    }
  }
  for (var i = 0; i < linker.length; i++) {
    for (var j = 0; j < no_ad_white_linker.length; j++) {
      if (linker[i] == no_ad_white_linker[j]) {
	return true;
      }
    }
  }
  if (no_ad_allow_self_domain_linker) {
    var tmp = document.createElement("a");
    tmp.href = url;
    var domain = tmp.hostname;
    for (var i = 0; i < linker.length; i++) {
      if (linker[i].match(/\@(.+)$/) && RegExp.$1 == domain) {
	return true;
      }
    }
  }
  var msg = "Greasemonkey:No Ad URL: Do you allow No Ad operation";
  if (linker.length > 0) {
    msg += " by " + linker.join(", ");
  }
  msg += "?";
  return window.confirm(msg);
}

function no_ad_check_date (url) {
  var s = url;
  var today = new Date();
  while (s.match(/[\&\?](?:no_ad_)?mature=([^\&]+)/)) {
    s = RegExp.rightContext;
    var d = new Date(decodeURIComponent(RegExp.$1));
    if (today > d) {
      return false;
    }
  }
  return true;
}

function no_ad_xpath (url, xpath) {
  var linker = [];
  var s = url;
  while (s.match(/[\&\?]linker=([^\&]+)/)) {
    s = RegExp.rightContext;
    var c = decodeURIComponent(RegExp.$1);
    linker.push(c);
  }
  var mature;
  s = url;
  while (s.match(/[\&\?](?:no_ad_)?mature=([^\&]+)/)) {
    s = RegExp.rightContext;
    mature = decodeURIComponent(RegExp.$1);
  }
  var title = "";
  if (mature) {
    title = "mature: " + mature;
  }
  if (linker.length > 0) {
    if (title != "") {
      title += ".  ";
    }
    title += "linker: " + linker.join(", ");
  }

  var res = document.evaluate(xpath, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
  for (var i = 0; i < res.snapshotLength; i++) {
    var node = res.snapshotItem(i);
    var c = document.createElement('canvas');
    c.className = "no-ad-replaced";
    c.width = node.offsetWidth;
    c.height = node.offsetHeight;
    if (title != "") {
      c.title = title;
    }
    var ctx = c.getContext('2d');
    ctx.strokeStyle = 'red';
    ctx.lineWidth = 3.0;
    ctx.moveTo(0, 0);
    ctx.lineTo(c.width - 1, c.height - 1);
    ctx.stroke();
    ctx.moveTo(c.width - 1, 0);
    ctx.lineTo(0, c.height - 1);
    ctx.stroke();
    ctx.font = '10px sans-serif';
    ctx.textAlign = 'center';
    ctx.strokeStyle = 'white';
    ctx.strokeText("No_Ad_URL", c.width / 2, c.height / 2);
    ctx.fillStyle = 'black';
    ctx.fillText("No_Ad_URL", c.width / 2, c.height / 2);
    var p = node.parentNode;
    p.replaceChild(c, node);
  }
}

function no_ad_click (url, xpath) {
  var res = document.evaluate(xpath, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
  for (var i = 0; i < res.snapshotLength; i++) {
    var node = res.snapshotItem(i);
    var ev = document.createEvent("MouseEvents");
    ev.initEvent("click", false, true);
    node.dispatchEvent(ev);
  }
}

function no_ad_classify (url, cl, xpath) {
  var del = false;
  if (cl.match(/^\s*-\s*/)) {
    cl = RegExp.rightContext;
    del = true;
  }
  var res = document.evaluate(xpath, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
  for (var i = 0; i < res.snapshotLength; i++) {
    var node = res.snapshotItem(i);
    var l = (node.className || "").split(/\s+/);
    if (! del) {
      l.push(cl);
    } else {
      var r = [];
      for (var j = 0; j < l.length; j++) {
	if (l[j].toLowerCase() != cl.toLowerCase()) {
	  r.push(l[j]);
	}
      }
      l = r;
    }
    node.className = l.join(" ");
  }
}

function no_ad_url (url) {
  var s = url;
  var confirmed = false;
    
  while (s.match(/[\&\?]no_ad=([^\&]+)/)) {
    s = RegExp.rightContext;
    var c = decodeURIComponent(RegExp.$1);
    if (! confirmed) {
      if (! no_ad_check_date(url)) {
	return;
      }
      if (! no_ad_check_linker(url)) {
	return;
      }
      confirmed = true;
    }
    if (c == "0" || c.toLowerCase() == "false") {
      // do nothing.
    } else if (c.match(/^id:/)) {
      no_ad_xpath(url, "//*[@id='" + RegExp.rightContext + "']");
    } else if (c.match(/^img:/)) {
      no_ad_xpath(url, "//img[@src='" + RegExp.rightContext + "']");
    } else if (c.match(/^xpath:/)) {
      no_ad_xpath(url, RegExp.rightContext);
    } else if (c.match(/^click:/)) {
      no_ad_click(url, RegExp.rightContext);
    } else if (c.match(/^classify:([^:]+):/)) {
      no_ad_classify(url, RegExp.$1, RegExp.rightContext);
    } else {
      window.alert("Greasemonkey:No Ad URL: No method for '" + c + "'");
    }
  }
}

no_ad_url(window.location.href);
