//
// upload_text.js 
//
// Time-stamp: <2011-05-19T12:57:36Z>
//
// An example code of "trusted hijack" of summoner.js which returns
// a magic number. part 2/2.
//

//
// License: 
//
//   Public Domain.
//
// Author's Link:
//
//   http://jrf.cocolog-nifty.com/software/2011/05/post.html
//   (The page is written in Japanese.)
//
// Notice:
// 
//   Besides setting uppercased variables properly, you must change
//   the prefix "YOUR_SERVER_HINT_" to avoid collision of function names.
//

//provide
var YOUR_SERVER_HINT_delegate_upload_text; // function

(function () {

var CLIENTS =
  [
    {key: "EFGH6789", log_server: "https://your.server/log_text_database.cgi"},
//    {key: "EFGH6789", log_server: "http://jrf.cocolog-nifty.com/statuses/"},
    null
  ];
	    

function upload_text(text, hash, updater, amcaller, chash, callback) {
  chrsz = 16;
  if (chash != hex_sha1(this.key + hash + updater + amcaller)) {
    // chash makes sense if SALT was shared by trustees.
    callback(null);
    return;
  }
  var data = "text=" + encodeURI(text) + "&hash=" + encodeURI(hash)
    + "&updater_hint=" + encodeURI(updater)
    + "&amcaller=" + encodeURI(amcaller)
    + "&uri=" + encodeURI(location.href);
//  alert(data);
//  console.log(data);
  var httpobj = requestFile(data, "POST", this.log_server, true, callback);
}

function bind(f,o) {
  return function() {return f.apply(o, arguments)};
}

function createHttpRequest() {
  if (window["ActiveXObject"]) {
    try {
      return new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      try {
        return new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e2) {
        return null;
      }
    }
  } else if (window["XMLHttpRequest"]) {
    return new XMLHttpRequest();
  } else {
    return null;
  }
}

function requestFile(data, method, fileName, async, on_loaded) {
  var httpoj = createHttpRequest();
  
  httpoj.open(method, fileName, async);
  httpoj.onreadystatechange = function() { 
    if (httpoj.readyState == 4 && on_loaded) { 
      on_loaded(httpoj);
    }
  }
  if (data) {
    httpoj.setRequestHeader("Content-Type",
			    "application/x-www-form-urlencoded");
  }
  httpoj.send(data);
  
  return httpoj;
}

// I conclude that there is no safe "inter-script" delegation in
// JavaScript.  The code below makes sense with Object.defineProperty
// which is a new feature of ECMA-262 5th edition or Firefox 4.
// Firefox 4 has yet multiple window per page mechanism internally.

var delegatable = true;
function delegate_upload_text (mes, chash) {
  for (var i = 0; i < CLIENTS.length; i++) {
    var cl = CLIENTS[i];
    if (cl && chash == hex_sha1(cl.key + mes)) {
      if (delegatable) {
	delegatable = false;
	return bind(upload_text, cl);
      }
    }
  }
  return null;
}

window.YOUR_SERVER_HINT_delegate_upload_text = delegate_upload_text;
if (typeof Object.defineProperty != "undefined") {
  Object.defineProperty(window, "YOUR_SERVER_HINT_delegate_upload_text", {
//if (typeof window.defineProperty != "undefined") {
//  window.defineProperty(window, "YOUR_SERVER_HINT_delegate_upload_text", {
    writable: false,
    enumerable: false,
    configurable: false
  });
}

// You may insert the contents of sha1.js here even if
// summoner_trusted.js "includes" it into document.

})();
