#!/usr/bin/perl
#require 5.008;
our $VERSION = "0.01"; #Time-stamp: <2014-02-07T12:44:16Z>

## License:
##
##   I in a provincial state made this program intended to be public-domain. 
##   But it might be better for you like me to treat this program as such 
##   under the BSD-License or under the Artistic License.
##
##   Within three months after the release of this program, I
##   especially admit responsibility of effort for rational request of
##   correction to this program.
##
## Author's Link:
##
##   http://jrf.cocolog-nifty.com/software/
##   (The page is written in Japanese.)
##

use strict;
use warnings;
use utf8; # Japanese English

use Encode;
use Encode::Guess;
$Encode::Guess::NoUTFAutoGuess = 1;

#our $FILENAME_ENCODER = Encode::find_encoding('cp932') or die;
our $FILENAME_ENCODER = Encode::find_encoding('utf8') or die;
#our $CONSOLE_ENCODER = Encode::find_encoding('cp932') or die;
our $CONSOLE_ENCODER = Encode::find_encoding('utf8') or die;
binmode(STDERR, ":utf8");

#use Getopt::Long;

our $QUERY;
our $FIND = "/bin/find";
our $VERBOSE = 0;
our $IGNORE_CASE = 0;

our @GUESS = qw/euc-jp shiftjis 7bit-jis utf8/;
#eval {require Encode::JIS2K};
#if (! $@) {
#  push(@GUESS, qw/euc-jisx0213 shiftjisx0213 iso-2022-jp-3/);
#}
push(@GUESS, qw/utf8/);

sub usage {
  my ($ext) = @_ || 0;
  print <<"EOU";
Usage: $0 [--verbose] [-i] QUERY ARGUMENTS_FOR_FIND_WITHOUT_LAST_-print
EOU
  exit($ext);
}

my @opt;
while (@ARGV && $ARGV[0] =~ /^-/) {
  if ($ARGV[0] eq '--') {
    shift(@ARGV);
    last;
  }
  push(@opt, shift(@ARGV));
}
if (@opt && grep {/^--?h(?:elp)?/i} @opt) {
  usage(0);
}
if (@opt && grep {$_ eq '-i' || $_ eq '--ignore-case'} @opt) {
  $IGNORE_CASE = 1;
  @opt = grep {! ($_ eq '-i' || $_ eq '--ignore-case')} @opt
}
if (@opt && grep {$_ eq '--verbose' || $_ eq '-v'} @opt) {
  $VERBOSE = 1;
  @opt = grep {! ($_ eq '--verbose' || $_ eq '-v')} @opt
}
if (@ARGV < 1 || @opt) {
  usage(1);
}

$QUERY = shift(@ARGV);
$QUERY = $CONSOLE_ENCODER->decode($QUERY);
$QUERY = ($IGNORE_CASE)? qr/$QUERY/io : qr/$QUERY/o;

MAIN: {
  push(@ARGV, "-print");
  open(my $fh, "-|", $FIND, @ARGV) or die "$FIND: $!";
  binmode($fh);
  while (my $f = <$fh>) {
    $f =~ s/[\n\r]+$//s;
    $f = $CONSOLE_ENCODER->decode($f);

    print $CONSOLE_ENCODER->encode("$f:\n") if $VERBOSE > 0;
    open(my $qh, "<", $FILENAME_ENCODER->encode($f)) or die "$f: $!";
    my $cont = join("", <$qh>);
    close($qh);
    my $enc = guess_encoding($cont, @GUESS);
    $cont = $enc->decode($cont) if ref $enc;
    my $l = 0;
    my (@l) = split(/[\n\r]+/, $cont);
    while (@l) {
      $l++;
      my $c = shift(@l);
      if ($c =~ $QUERY) {
	if ($VERBOSE > 0) {
	  print $CONSOLE_ENCODER->encode("$l:$c\n");
	} else {
	  print $CONSOLE_ENCODER->encode("$f:$l:$c\n");
	}
      }
    }
  }

  close($fh);
}
